---
title: IDBKeyRange.lowerBound()
slug: Web/API/IDBKeyRange/lowerBound
tags:
  - API
  - Database
  - IDBKeyRange
  - IndexedDB
  - Method
  - Reference
  - Storage
  - lowerBound
---
<p>{{ APIRef("IndexedDB") }}</p>

<div>
<p>The <strong><code>lowerBound()</code></strong> method of the {{domxref("IDBKeyRange")}} interface creates a new key range with only a lower bound. By default, it includes the lower endpoint value and is closed.</p>
</div>

<p>{{AvailableInWorkers}}</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate" style="font-size: 14px;">var <em>myIDBKeyRange</em> = <em>IDBKeyRange</em>.lowerBound(<em>lower</em>);
var <em>myIDBKeyRange</em> = <em>IDBKeyRange</em>.lowerBound(<em>lower</em>, <em>open</em>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>lower </dt>
 <dd>specifies the lower bound of the new key range. </dd>
 <dt>open<em> </em>{{optional_inline}}</dt>
 <dd>indicates whether the lower bound excludes the endpoint value. The default is false. </dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>{{domxref("IDBKeyRange")}}: The newly created key range.</p>

<h3 id="Exceptions">Exceptions</h3>

<p>This method may raise a {{domxref("DOMException")}} of the following type:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Exception</th>
   <th scope="col">Description</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><font face="Courier New, Andale Mono, monospace"><span style="line-height: normal;">DataError</span></font></td>
   <td>
    <p>The value parameter passed was not a valid key.</p>
   </td>
  </tr>
 </tbody>
</table>

<h2 id="Example">Example</h2>

<p>The following example illustrates how you'd use a lower bound key range. Here we declare <code>keyRangeValue = IDBKeyRange.lowerBound("F", false);</code> — a range that includes the value "F" and everthing after it. We open a transaction (using {{domxref("IDBTransaction")}}) and an object store, and open a Cursor with {{domxref("IDBObjectStore.openCursor")}}, declaring <code>keyRangeValue</code> as its optional key range value. This means that the cursor will only retrieve the record with the key value "F" and all that come after it. If we used <code>IDBKeyRange.lowerBound("F", true);</code>, then the range would not include "F"; only the values after it.</p>

<div class="note">
<p><strong>Note</strong>: For a more complete example allowing you to experiment with key range, have a look at our <a href="https://github.com/mdn/indexeddb-examples/tree/master/idbkeyrange">IDBKeyRange-example</a> repo (<a href="https://mdn.github.io/indexeddb-examples/idbkeyrange/">view the example live too</a>.)</p>
</div>

<pre class="brush: js notranslate" style="font-size: 14px;">function displayData() {
  var keyRangeValue = IDBKeyRange.lowerBound("F");

  var transaction = db.transaction(['fThings'], 'readonly');
  var objectStore = transaction.objectStore('fThings');

  objectStore.openCursor(keyRangeValue).onsuccess = function(event) {
    var cursor = event.target.result;
      if(cursor) {
        var listItem = document.createElement('li');
        listItem.innerHTML = '&lt;strong&gt;' + cursor.value.fThing + '&lt;/strong&gt;, ' + cursor.value.fRating;
        list.appendChild(listItem);

        cursor.continue();
      } else {
        console.log('Entries all displayed.');
      }
    };
  };</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 2", "#dom-idbkeyrange-lowerbound-lower-loweropen", "lowerBound()")}}</td>
   <td>{{Spec2("IndexedDB 2")}}</td>
   <td></td>
  </tr>
  <tr>
   <td>{{SpecName("IndexedDB 3", "#dom-idbkeyrange-lowerbound", "lowerBound()")}}</td>
   <td>{{Spec2("IndexedDB 3")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.IDBKeyRange.lowerBound")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a></li>
 <li>Starting transactions: {{domxref("IDBDatabase")}}</li>
 <li>Using transactions: {{domxref("IDBTransaction")}}</li>
 <li>Setting a range of keys: {{domxref("IDBKeyRange")}}</li>
 <li>Retrieving and making changes to your data: {{domxref("IDBObjectStore")}}</li>
 <li>Using cursors: {{domxref("IDBCursor")}}</li>
 <li>Reference example: <a class="external" href="https://github.com/mdn/to-do-notifications/tree/gh-pages">To-do Notifications</a> (<a class="external" href="https://mdn.github.io/to-do-notifications/">view example live</a>.)</li>
</ul>
